<?php
/*
 * Copyright (c) 2009, The members of Ouga! project
 * Etienne Deparis <etienne.deparis@umaneti.net>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 *
 * modification, are permitted provided that the following conditions
 * are met:
 *  - Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  - Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  - Neither the name of the Ouga! project nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 */

function controller(&$variables){

	$variables['current_file'][] = 'controller';

	// Call of first hook
	run_hook(1, $variables);

	if(OUGA_USE_ACL){
		if(!component('acl')->check(
			$variables['user']->login,
			$variables['path']
		)) throw_error('403');
	}

	// fichier de lancement du module
	require_once get_module($variables['module']);

	if(function_exists($variables['module'].'_init')){
		$function = $variables['module'].'_init';
		$function($variables);
		if($variables['path'][0] != $variables['module'])
			$variables['path'][0] = $variables['module'];
		if($variables['path'][1] != $variables['page'])
			$variables['path'][1] = $variables['page'];
	}

	// Call of second hook
	run_hook(2, $variables);

	if(OUGA_USE_ACL){
		if(!component('acl')->check(
			$variables['user']->login,
			$variables['path']
		)) throw_error('403');
	}

	if(function_exists(
		$variables['module'] . '_' . $variables['page']
		)){
		$function = $variables['module'] . '_' . $variables['page'];
		$function($variables);
	}else if(function_exists(
		$variables['module'] . '_' . $variables['module'])
		){
		$function = $variables['module'] . '_' . $variables['module'];
		$function($variables);
	}else throw_error(404);

	// Call of third hook
	run_hook(3, $variables);
	component('display')->render($variables);

	cleanup_all();
}
?>
