<?php
/*
 * Copyright (c) 2009, The members of Ouga! project
 * Etienne Deparis <etienne.deparis@umaneti.net>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 *
 * modification, are permitted provided that the following conditions are
 * met:
 *  - Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  - Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *  - Neither the name of the Ouga! project nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

/**
 * Throw an error
 * @return nothing
 * @param Mixed $erno[optional] : the error reference
 */
function throw_error($erno = 'unknown', $args = false) {
	global $variables;

	if(!in_array($erno, array('fatal','warning','404','403','unknown'))){
		require_once path_to_module($variables['module'], false)
			. 'error.php';
	}
	$func = 'error_'.$erno;
	$variables['content'] = $func($args);
	$variables['hook_readonly'] = true;
	$variables['module_title'] = 'Error';

	component('display')->render($variables);
	cleanup_all();
	exit;
}

function error_fatal($args){
	switch($args){
		case 2 : return _(
				'The file you tried to send is toooo heavy. Please try to reduce it before send it to our website.'
			);
			break;
		case 3 : return _(
				'Unknown error during file transfer. Please retry.'
			);
			break;
		case 4 : return _(
				'We don\'t support this file format. Sorry'
			);
			break;
		case 5 : return _(
				'You don\'t have the rights to delete this file.'
			);
			break;
		case 6 : return _(
				'No account match your request. Please retry.'
			);
			break;
		case 8 : return _(
				'Your article has no title or no content... Don\'t forget to fill them.'
			);
			break;
		case 9 : return _('No article found with this ID.');
			break;
		default : return _($args);
	}
}

function error_warning($args){
	return _($args);
}

function error_unknown($args){
	return _('An unknown error occured. Sorry for the unconvenience.');
}

function error_404($args){
	header('HTTP/1.1 404 Not Found');
	return _('404 - File not found');
}

function error_403($args){
	header('HTTP/1.1 403 Forbidden');
	return _('403 - Forbidden');
}
?>
