<?php
/*
 * Copyright (c) 2009, The members of Ouga! project
 * Etienne Deparis <etienne.deparis@umaneti.net>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 *
 * modification, are permitted provided that the following conditions are
 * met:
 *  - Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  - Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *  - Neither the name of the Ouga! project nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

$bddmodel = array(
	'variables' => array(
		'fields' => array(
			'name' => array(
				'type' => 'varchar',
				'length' => 255,
				'null' => false,
			),
			'content' => array(
				'type' => 'text',
				'null' => false,
			),
		),
	),
	'acl_paths' => array(
		'fields' => array(
			'path' => array(
				'type' => 'varchar',
				'length' => 255,
				'null' => false,
				'default' => '*',
			),
			'aid' => array(
				'type' => 'text',
				'null' => false,
				'default' => 0,
			),
			'follow' => array(
				'type' => 'varchar',
				'length' => 255,
			),
			'title' => array(
				'type' => 'varchar',
				'length' => 255,
			),
		),
		'primary_key' => array('path'),
	),
	'acl_users' => array(
		'fields' => array(
			'login' => array(
				'type' => 'varchar',
				'length' => 25,
				'null' => false,
				'default' => 0,
			),
			'aid' => array(
				'type' => 'int',
				'length' => 11,
				'null' => false,
				'default' => 1,
			),
		),
		'primary_key' => array('login'),
	),
	'acl_groups' => array(
		'fields' => array(
			'aid' => array(
				'type' => 'int',
				'length' => 11,
				'null' => false,
				'auto_inc' => true
			),
			'label' => array(
				'type' => 'varchar',
				'length' => 255,
				'null' => false,
			),
		),
		'primary_key' => array('aid'),
	),
);

$installstring = array();

foreach($bddmodel as $table => $data){
	$installstring[] = parse_query_array(
		array(
			'type' => 'create',
			'table' => $table,
			'fields' => $data['fields'],
			'primary_key' => $data['primary_key'],
		)
	);
}

// installons les tables de base de l'application
bdd_query($installstring, true);
bdd_query(
	"insert into {variables} values('installed_modules', '"
	. serialize(array())
	. "')"
);

?>
