<?php
/*
 * Copyright (c) 2009, The members of Ouga! project
 * Etienne Deparis <etienne.deparis@umaneti.net>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 *
 * modification, are permitted provided that the following conditions are
 * met:
 *  - Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  - Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *  - Neither the name of the Ouga! project nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

function __($trad,$arrayval){
	$u = 1;
	foreach($arrayval as $var){
		$trad = str_replace('%'.$u, $var, $trad);
		$u++;
	}
	return $trad;
}

function get_locale(){
	global $variables;
	return $variables['lang'];
}

function set_lang(){
	global $variables;

	if(isset($variables['user']->lang)){
		setlocale(LC_ALL, $variables['user']->lang.'.UTF8');
		$variables['lang'] = $variables['user']->lang;
	}
	setlocale(LC_ALL, $variables['lang'].'.UTF8');
}

function get_lang($lgfor = 'theme') {

	if($lgfor == 'theme'){
		bindtextdomain(
			'default',
			_exists('themes/' . OUGA_THEME . '/lang')
		);
		textdomain('default');
	}else{
		bindtextdomain('module', _exists('modules/'.$lgfor.'/lang'));
		textdomain('module');
	}

}

if($variables['lang']){
	if(in_array($variables['module'], $variables['modules_list'])
		|| $variables['module'] == 'install'){
		set_lang();
	}
}
?>
