<?php
/*
 * module/document/modele.php
 *
 * All Ouga code is released under the GNU General Public License.
 * See README and LICENSE.
 *
 */

define('DOCUMENT_DRAFT', 1);
define('DOCUMENT_PRIVATE', 2);
define('DOCUMENT_PUBLISHED', 3);
define('PAGER_SIMPLE', 1);
define('PAGER_FULL', 2);
define('DOCUMENT_ARTICLES_PER_PAGE',5);

class document {
	public $did = 0;
	public $url = '';
	public $title = '';
	public $content = '';
	public $author = '';
	public $date = 0;
	public $tags = array();
	private $type = 1;

	public function __construct($did = '', $data = null){
		if($did != 'new' && $data == null){
			$this->load(strclean($did));
		}else{
			$this->did = strclean($did);

			if($data != null){
				if(!$data['from_bd']){
					foreach($data as $key => $value){
						if($key != 'tags' && $key != 'author') $data[$key] = strclean($value);
					}
				}
				$this->url = $data['url'];
				$this->title = $data['title'];
				$this->content = $data['content'];
				$this->type = $data['type'];
				if ($data['date'] != '') $this->date = $data['date'];
				else $this->date = time();
				$this->author = $data['author'];
				$tags = explode(',',strclean($data['tags']));
				$this->tags = array();
				foreach ($tags as $tag) {
					$tag = trim($tag);
					if($tag != ''){
						$vart = bdd_query("SELECT weight FROM {tags} WHERE tag = '$tag'");
						if($nbt = bdd_fetch($vart))
							$this->tags[$tag] = $nbt['nbr'];
						else
							$this->tags[$tag] = 0;
					}
				}
			}
		}
	}

	public function get_type(){
		return $this->type;
	}

	public function get_format(){
		return substr(strtolower($this->url),-4);
	}

	public function get_miniimg(){
		$urltab = explode('/', $this->url);
		$i = sizeof($urltab) - 1;
		$urltab[$i] = 'mini_'.$urltab[$i];
		return implode('/', $urltab);
	}

	public function load($did){
		$contenu = bdd_query("SELECT url, title, content, author, date, type, tags FROM {documents} WHERE did = '$did'");
		if($document = bdd_fetch($contenu)){
			$this->did = $did;
			$this->url = $document['url'];
			$this->type = $document['type'];
			$this->author = $document['author'];
			$this->title = $document['title'];
			$this->content = $document['content'];
			$this->date = $document['date'];
			$tags = explode(',',$document['tags']);
			foreach ($tags as $tag) {
				$tag = trim($tag);
				$vart = bdd_query("SELECT weight FROM {tags} WHERE tag = '$tag'");
				$nbt = bdd_fetch($vart);
				$this->tags[$tag] = $nbt['weight'];
			}
		}else{
			throw_error('404');
		}
	}

	public function save() {
		if($this->did == 'new'){
			$title = $this->title;
			$content = $this->content;
			$date = $this->date;
			$author = $this->author;
			$type = $this->type;
			$tags = '';
			if($this->tags){
				foreach($this->tags as $tagd => $nbt){
					$tag = trim($tagd);
					if($tag != '' && $tag != NULL && $tag != ' ' && !empty($tag)){
						$dd = bdd_query("select weight from {tags} where tag = '$tag'");
						if (bdd_count() < 1) bdd_query("insert into {tags} values('$tag', 1)");
						else bdd_query("update {tags} set weight = weight + 1 where tag = '$tag'");
					}
					$tags .= $tag.',';
				}
			}
			$tags = substr($tags,0,-1);

			// gestion des fichiers
			if($this->url == 'new-file'){
			    if($_FILES['fileup']['error'] == 0){
			    	// Get some informations
			   		$filename = $_FILES['fileup']['name'];
			    	$source = $_FILES['fileup']['tmp_name'];
			       	$target = 'repository/'.$_SERVER['SERVER_NAME'].'/cache/'.$date.$filename;

					// Ok, movin' the file
			       	move_uploaded_file($source, $target);

					// get the file type by its extension.
			       	$format = substr(strtolower($filename),-4);

					// We have to work a bit with image file
					switch($format){
						case '.png' :
							$bigimg = imagecreatefrompng($target);
							$dofunc = 'imagepng';
							break;
						case '.jpg' :
						case 'jpeg' :
							$bigimg = imagecreatefromjpeg($target);
							$dofunc = 'imagejpeg';
							break;
						case 'gif' :
							$bigimg = imagecreatefromgif($target);
							$dofunc = 'imagegif';
							break;
						default : $bigimg = false;
					}

					// we can now create a little representative picture ^^
					if($bigimg){
				   		$width_source = imagesx($bigimg);
				   		$height_source = imagesy($bigimg);
				   		$width_target = 100;
				   		$height_target = (100 * $height_source) / $width_source;
				   		$littleimg = imagecreatetruecolor($width_target, $height_target);
				   		imagecopyresampled($littleimg, $bigimg, 0, 0, 0, 0, $width_target, $height_target, $width_source, $height_source);
						$dofunc($littleimg, 'repository/'.$_SERVER['SERVER_NAME'].'/cache/mini_'.$date.$filename);
			       	}
					$target = base_path().$target;
				}elseif($_FILES['fichup']['error'] == 1 || $_FILES['fichup']['error'] == 2){
				    throw_error('fatal/2');
			    }else{
				    throw_error('fatal/3');
			    }
			}

			$bidu = bdd_query("INSERT INTO {documents} VALUES('','$target','$title','$content','$author','$date','$tags','$type')", true);
			if($this->get_type() == DOCUMENT_DRAFT) return base_path().'document/edit/'.bdd_last_id().'/ok';
			return base_path().'document/'.bdd_last_id().'/'.strtoascii($this->title);
		}else return $this->update();
	}

	public function update() {
		if($this->did != 'new'){
			$did = $this->did;
			if($did != ''){
				$title = $this->title;
				$content = $this->content;
				$type = $this->type;

				$oldtags = bdd_query("select tags from {documents} where did = '$did'");
				$dattag = bdd_fetch($oldtags);
				if ($dattag['tags'] != ''){
					$oldtags = explode(',', $dattag['tags']);
					$tags = array();
					foreach($this->tags as $tag => $nbt) $tags[] = $tag;

					$ttr = array_diff($oldtags, $tags);
					$tta = array_diff($tags, $oldtags);

					foreach($ttr as $tr){
						bdd_query("update {tags} set weight = weight - 1 where tag = '$tr'");
					}

					foreach($tta as $ta){
						if($ta != '' && $ta != NULL && $ta != ' ' && !empty($ta)){
							$dd = bdd_query("select weight from {tags} where tag = '$ta'");
							if (bdd_count() < 1) bdd_query("insert into {tags} values('$ta', 1)");
							else bdd_query("update {tags} set weight = weight + 1 where tag = '$ta'");
						}
					}
				}
				bdd_query("delete from {tags} where weight = 0");

				$tags = '';
				foreach($this->tags as $tag => $nbt) $tags .= $tag.',';
				$tags = substr($tags,0,-1);

				bdd_query("UPDATE {documents} set title = '$title', content = '$content', type = '$type', tags = '$tags' WHERE did = '$did'",true);
				if($this->get_type() == DOCUMENT_DRAFT) return base_path().'document/edit/'.$did.'/ok';
				return base_path().'document/'.$did.'/'.strtoascii($this->title);
			}else throw_error('fatal/9');
		}else return $this->save();
	}

	public function delete(){
		if(ctype_digit($this->did)){
			$pageid = $this->did;
			if($this->url != ''){
				$url = substr($this->url, 1);
				$flag = explode('/', $url);
				if('/'.$flag[0].'/' == base_path()) array_shift($flag);
				unlink(implode('/', $flag));
				$i = sizeof($flag) - 1;
				$flag[$i] = 'mini_'.$flag[$i];
				unlink(implode('/', $flag));
			}
			foreach($this->tags as $tag => $weight){
				$weight--;
				bdd_query("UPDATE {tags} set weight = $weight where tag = '$tag'");
			}
			bdd_query(array("delete from {tags} where weight = 0","DELETE FROM {documents} WHERE did = $pageid"), array(true, true));
		}
	}

	public function affiche_simple_date(){
		$date = date("YmdHis", $this->date);
		$lang = get_locale();
		$an = substr($date,0,4);
		$mois = substr($date,4,2);
		$jour = substr($date,6,2);
		$heure = substr($date,8,2);
		$min = substr($date,10,2);
		$sec = substr($date,12,2);
		if($lang == 'en_US')
			return $mois.'/'.$jour.'/'.$an.' at '.$heure.':'.$min;
		return $jour.'/'.$mois.'/'.$an.' à '.$heure.':'.$min;
	}

	public function affiche_date(){
		$lang = get_locale();
		$date = date("YmdHis", $this->date);
		$an = substr($date,0,4);
		$mois = substr($date,4,2);
		$jour = substr($date,6,2);
		$heure = substr($date,8,2);
		$min = substr($date,10,2);
		$sec = substr($date,12,2);
		$date = mktime($heure,$min,$sec,$mois,$jour,$an);

		$tabjourfr = array('Dimanche','Lundi','Mardi','Mercredi','Jeudi','Vendredi','Samedi');
		$tabjouren = array('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday');
		$tabmoisfr = array('Janvier','Février','Mars','Avril','Mai','Juin','Juillet','Août','Septembre','Octobre','Novembre','Décembre');
		$tabmoisen = array('Januar','Februar','March','April','May','Juny','July','August','September','October','November','December');

		$numjour = date('w',$date);
		if($lang == 'en_US'){
			$jourok= $tabjouren[$numjour];
			$mois--;
			$moisok= $tabmoisen[$mois];
			return $jourok.' '.$jour.' '.$moisok.' '.$an.' at '.$heure.':'.$min;
		}
		$jourok= $tabjourfr[$numjour];
		$mois--;
		$moisok= $tabmoisfr[$mois];
		return $jourok.' '.$jour.' '.$moisok.' '.$an.' à '.$heure.':'.$min;
	}

	public function get_content(){
		return strdirty($this->content);
	}

	public function get_urlizedTitle(){
		return strtoascii($this->title);
	}
}

function load_array_of_document($nbr = DOCUMENT_ARTICLES_PER_PAGE, $criterion = '', $order = 'date desc', $type = DOCUMENT_PUBLISHED, $start = 0){
	$return = array();

	$sql = 'SELECT did, url, title, content, author, date, type, tags FROM {documents} ';

	if($criterion != '') $sql .= 'WHERE '.$criterion;

	if($criterion == '' && $type != '*') $sql .= 'WHERE type = '.$type;
	else if($type != '*') $sql .= ' AND type = '.$type;

	$sql .= ' ORDER BY '.$order.' LIMIT '.$start.','.$nbr;

	$artdata = bdd_query($sql, true);

	while($article_item = bdd_fetch($artdata)){
			$return[] = new document($article_item['did'],array(
														'from_bd' => true,
														'url' => $article_item['url'],
														'title' => $article_item['title'],
														'content' => $article_item['content'],
														'author' => $article_item['author'],
														'tags' => $article_item['tags'],
														'type' => $article_item['type'],
														'date' => $article_item['date']));
		}

	return $return;
}

function document_get_pager($type = DOCUMENT_PUBLISHED){

	if(get_arg(0) == 'document'){
		if(get_arg(1) == 'tags'){
			if(ctype_digit(get_arg(3))) $current_page = get_arg(3);
			else $current_page = 1;
		}else{
			if(ctype_digit(get_arg(2))) $current_page = get_arg(2);
			else $current_page = 1;
		}
	}else return false;

	if(ctype_digit($type))
		$data = bdd_query("select count(did) as nbr from {documents} where type = $type");
	else if($type == '*')
		$data = bdd_query("select count(did) as nbr from {documents}");
	else return false;
	$content = bdd_fetch($data);

	$previous = $current_page - 1;
	if($previous <= 0) $previous = false;

	$next = $current_page + 1;
	if($next >= $content['nbr']) $next = false;

	if($content['nbr'] <= DOCUMENT_ARTICLES_PER_PAGE) $total = false;
	else $total = $content['nbr'];

	$pager = array(
				'previous' => $previous,
				'next' => $next,
				'current' => $current,
				'total' => $total
	);

	return $pager;

}

/**
 *
 * @return string
 * @param pager array The pager data information, from document_get_pager for instance
 * @param int sort[optional] The pager format. Can be PAGER_FULL or PAGER_SIMPLE.
 */
function format_html_pager($pager, $sort = PAGER_FULL){
	if($pager && $pager['total']){
		$output = '';
		switch($form){
			case PAGER_SIMPLE :
				$output = '<ul class="pager">';
				if($pager['previous']) $output .= '<li class="pager_item"><a href="'.base_path().'document/list/'.$pager['previous'].'">'._('Previous').'</a></li>';
				if($pager['next']) $output .= '<li class="pager_item"><a href="'.base_path().'document/list/'.$pager['next'].'">'._('Next').'</a></li>';
				$output .= '</ul>';
				break;
			case PAGER_FULL :
			default :
				$nbpage = $pager['total'] / DOCUMENT_ARTICLES_PER_PAGE;
				$output = '<ul class="pager">';
				if($pager['previous']) $output .= '<li class="pager_item"><a href="'.base_path().'document/list/'.$pager['previous'].'">'._('Previous').'</a></li>';
				for($i = 1 ; $i <=  $nbpage ; $i++)
					$output .= '<li class="pager_item"><a href="'.base_path().'document/list/'.$i.'">'.$i.'</a></li>';
				if($pager['next']) $output .= '<li class="pager_item"><a href="'.base_path().'document/list/'.$pager['next'].'">'._('Next').'</a></li>';
				$output .= '</ul>';
		}
		return $output;
	}
	return false;
}
?>
