<?php
/*
 * Copyright (c) 2009, The members of Ouga! project
 * Etienne Deparis <etienne.deparis@umaneti.net>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 *
 * modification, are permitted provided that the following conditions
 * are met:
 *  - Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  - Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  - Neither the name of the Ouga! project nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 */

function group_init(&$variables){
	use_modele('user');
	if($variables['page'] == '<none>') $variables['page'] = 'groups';
	$variables['header']['style']['screen'][]
		= path_to_module('group') . 'views/style.css';
}

function group_groups(&$variables){
	$data = bdd_query(
		"select aid, label from {acl_groups} order by label"
	);
	$variables['groups'] = null;
	while($g = bdd_fetch($data)){
		$variables['groups'][] = $g;
	}

	// Left user group
	if($_SESSION['gl'] && $_SESSION['gl'] != 'all'){
		$aid = $_SESSION['gl'];
		$variables['member_list_left'] = list_users(
			"u.login = a.login AND a.aid = '$aid'",
			'login',
			array('table' => '{acl_users} a')
		);
	}else $variables['member_list_left'] = list_users(null, 'login');

	// Right user group
	if($_SESSION['gr'] && $_SESSION['gr'] != 'all'){
		$aid = $_SESSION['gr'];
		$variables['member_list_right'] = list_users(
			"u.login = a.login AND a.aid = '$aid'",
			'login',
			array('table' => '{acl_users} a')
		);
	}else $variables['member_list_right'] = list_users(null, 'login');

	$variables['header']['script'][]
		= path_to_module('document') . 'inc/lib_list.js';
	$variables['header']['script'][]
		= base_path() . 'core/lib/js/ajax.js';
}

function group_rights(&$variables){
	$data = bdd_query(
		"select aid, label from {acl_groups} order by label"
	);
	$variables['groups'] = array();
	while($g = bdd_fetch($data)){
		$variables['groups'][] = $g;
	}

	$rightcontent = bdd_query(
		"select p.path, p.aid, p.title
		from {acl_paths} p
		where p.title <> ''"
	);
	$variables['rightlist'] = array();

	while($rl = bdd_fetch($rightcontent)){
		$variables['rightlist'][$rl['path']]
			= array($rl['title'], $rl['aid']);
	}

}

function group_ajax(&$variables){
	if(isset($_POST['group'])){
		$aid = strclean($_POST['group']);
		header('Content-Type: application/xml');
		header('Cache-Control: no-cache');
		echo '<?xml version="1.0" ?>';
		echo '<users>';

		if($aid == 'all') $users = list_users(null, 'login');
		else $users = list_users(
			"u.login = a.login AND a.aid = '$aid'",
			'login',
			array('table' => '{acl_users} a')
		);

		foreach($users as $l => $u){
			if(empty($u->firstname) && empty($u->lastname)){
				echo '<user value="' . $l . '">' . $l . '</user>';
			}else{
				echo '<user value="' . $l . '">' . $u->firstname
					. ' ' . $u->lastname . '</user>';
			}
		}
		echo '</users>';
	}
	exit;
}

function group_register(&$variables){
	if(isset($_POST['groupname']) && !empty($_POST['groupname'])){
		$groupname = strclean($_POST['groupname']);
		bdd_query(
			"insert into {acl_groups} values('', '$groupname')",
			true
		);
	}
	header('location: '.base_path().'group/groups');
	exit;
}

function group_do(&$variables){
	if(isset($_POST['action']) && !empty($_POST['action'])){
		$action = strclean($_POST['action']);
		switch($action){
			case 'addtogrp' :
				if(isset($_POST['namegroupleft'])
					&& !empty($_POST['namegroupleft'])
					&& isset($_POST['namegroupright'])
					&& !empty($_POST['namegroupright'])){

					$namegl = strclean($_POST['namegroupleft']);
					$_SESSION['gl'] = $namegl;
					if($namegl == 'all') $namegl = 1;
					$namegr = strclean($_POST['namegroupright']);
					$_SESSION['gr'] = $namegr;
					if($namegr == 'all') $namegr = 1;

					if(isset($_POST['usergroupleft'])
						&& !empty($_POST['usergroupleft'])){

						$idlusers = $_POST['usergroupleft'];
						$contenu = bdd_query(
							"select login from {acl_users}
							where aid = '$namegr'"
						);
						$loggravant = array();
						while($u = bdd_fetch($contenu))
							$loggravant[] = $u['login'];

						foreach($idlusers as $l){
							if(!in_array($l, $loggravant))
								bdd_query(
									"update {acl_users}
									set aid = '$namegr'
									where login = '$l'"
								);
						}
					}

					if(isset($_POST['usergroupright'])
						&& !empty($_POST['usergroupright'])){

						$idrusers = $_POST['usergroupright'];
						$contenu = bdd_query(
							"select login from {acl_users}
							where aid = '$namegl'"
						);
						$logglavant = array();
						while($u = bdd_fetch($contenu))
							$logglavant[] = $u['login'];

						foreach($idrusers as $l){
							if(!in_array($l, $logglavant))
								bdd_query(
									"update {acl_users}
									set aid = '$namegl'
									where login = '$l'"
								);
						}
					}
				}
				$return = 'groups';
				break;
			case 'chggrprights' :
				$queries = array();

				$rightcontent = bdd_query(
					"select p.path, p.aid, p.title
					from {acl_paths} p
					where p.title <> ''"
				);

				while($rl = bdd_fetch($rightcontent)){
					$rs[$rl['path']] = $rl['aid'];
					if(isset($_POST['rights'][$rl['path']])){
						$aids
							= serialize($_POST['rights'][$rl['path']]);

						$queries[] = 'update {acl_paths} set aid = \''
							. $aids . '\' where path = \'' . $rl['path']
							. '\' or follow = \'' . $rl['path'] . '\'';
					}else{
						$queries[] = 'update {acl_paths} set aid = \''
							. '0\' where path = \'' . $rl['path']
							. '\' or follow = \'' . $rl['path'] . '\'';
					}
				}

				$mynewgrp = strclean($_POST['grpchg']);
				$queries[] = 'update {acl_users} set aid = \''
					. $mynewgrp . '\' where login = \''
					. $variables['user']->login . '\'';
				bdd_query($queries);
				$return = 'rights';
				break;
		}
	}
	header('location: '.base_path().'group/'.$return);exit;
}

?>
