<?php
/*
 * Copyright (c) 2009, The members of Ouga! project
 * Etienne Deparis <etienne.deparis@umaneti.net>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 *
 * modification, are permitted provided that the following conditions
 * are met:
 *  - Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  - Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  - Neither the name of the Ouga! project nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 */

define('USER_AUTH_METHOD', 'sql'); // value = sql or ldap
define('USER_REGISTER', true); // to permit user registration, set this to true... or false to disallow.

function user_init(&$variables){

	if($variables['page'] == '<none>') $variables['page'] = 'list';
	if($variables['page'] == 'register' && !get_arg(2))
		$variables['path'][2] = 'form';

	$variables['header']['style']['screen'][]
		= path_to_module('document') . 'views/inc/style.css';
	$variables['header']['style']['screen'][]
		= path_to_module('user') . 'views/inc/style.css';
}

function user_list(&$variables){

	$variables['member_list'] = list_users(null, 'lastname');

	$variables['header']['script'][] = path_to_module('document')
		. 'views/inc/lib_list.js';
}

function user_admin(&$variables){
	user_list($variables);
}

function user_register(&$variables){
	if(USER_REGISTER && get_arg(2)){
		if(get_arg(2) == 'save' &&
		   isset($_POST['date']) &&
		   !empty($_POST['date'])){
			$loginfield = $_POST['date'];
			if(isset($_POST[$loginfield])
				&& isset($_POST['pass1'])
				&& isset($_POST['pass2'])
				&& !empty($_POST[$loginfield])
				&& !empty($_POST['pass1'])
				&& !empty($_POST['pass2'])){
				if($_POST['pass1'] == $_POST['pass2']){

					$newuser = new user(
						$_POST[$loginfield],
						array('state' => 'new')
					);

					if(!$newuser->user_exists()){
						$newuser->save($_POST['pass1']);

						$he = $newuser->login;
						component('acl')->discover_user($he);

						$fin = time() + 31536000;
						$user_agent = $_SERVER['HTTP_USER_AGENT']
							. ' ' . $_SERVER['REMOTE_ADDR'];
						$key = get_secret_things(10);
						$iv = get_secret_things(
							mcrypt_get_iv_size(
								MCRYPT_RIJNDAEL_256,
								MCRYPT_MODE_CFB
							)
						);
						$arraykey = serialize(array($key,$iv));
						$mouette = cookie_nuts(
							$he . $fin . $user_agent,
							$key,
							$iv
						);
						setcookie('nougat',$mouette,$fin,base_path());
						bdd_query("UPDATE {users} SET lastsid = '$fin', arraykey = '$arraykey', sid = '$mouette' WHERE login = '$he'", true);
						header('location: ' . base_path()
							. 'user/edit');
						exit;
					}else throw_error('user', 'exists');
				}else throw_error('user', 'pass');
			}
		}
	}else throw_error(403);
}

function user_edit(&$variables){
	if($variables['user']->is_logged()){
		$iduti = $variables['user']->login;
		if(get_arg(2))
			$iduti = strclean(get_arg(2));
		$variables['account_item'] = new user($iduti);
	}else throw_error(403);
}

function user_profile(&$variables){
	if(get_arg(2)){
		$iduti = get_arg(2);
		$variables['profile_item'] = new user($iduti);
		if($variables['profile_item']->get_state() == USER_NOT_FOUND){
			throw_error('nouser', $variables['profile_item']->login);
		}
		$variables['header']['script'][] = base_path()
			. 'core/lib/js/ajax.js';
		$variables['theme'] = 'ouga';
	}else throw_error('nouser', 'no_login');
}

function user_switch_state(&$variables){
	if(get_arg(2) && get_arg(3)){
		$iduti = get_arg(2);
		switch(get_arg(3)){
			case 'on' :
				$contenu = bdd_query("UPDATE {users} SET state = 1 WHERE login='$iduti'");
				break;
			case 'off' :
				$contenu = bdd_query("UPDATE {users} SET state = 0 WHERE login='$iduti'");
				break;
			default : throw_error('user', 'xx');
		}
		header('location: '.base_path().'user/admin/ok');exit;
	}
}

function user_groupdo(&$variables){
	if(isset($_POST['action']) && !empty($_POST['action'])){
		$action = strclean($_POST['action']);
		switch($action){
			case 'deactivate' :
							if(isset($_POST['user'])
							&& !empty($_POST['user'])){
								$idusers = $_POST['user'];
								foreach($idusers as $iduti)
									$contenu = bdd_query(
										'UPDATE {users} SET state = 0'
											. ' WHERE login='
											. "'" . strclean($iduti)
											. "'"
									);
							}
							$return = 'list';
							break;
			case 'activate' :
							if(isset($_POST['user'])
							&& !empty($_POST['user'])){
								$idusers = $_POST['user'];
								foreach($idusers as $iduti)
									$contenu = bdd_query(
										'UPDATE {users} SET state = 1'
											. ' WHERE login='
											. "'" . strclean($iduti)
											. "'"
									);
							}
							$return = 'admin';
							break;
		}
	}
	header('location: '.base_path().'user/'.$return);exit;
}

function user_password(&$variables){
	if($variables['user']->is_logged() && get_arg(2) == 'edit'){
		if(isset($_POST['pass1']) &&
		isset($_POST['pass2']) &&
		isset($_POST['pass3']) &&
		!empty($_POST['pass1']) &&
		!empty($_POST['pass2']) &&
		!empty($_POST['pass3'])){
			$iduti = strclean($_POST['modiduti']);
			$contenu = bdd_query("SELECT password,state FROM {users} WHERE login='$iduti'");
			$affich = bdd_fetch($contenu);
			$sameuser = false;

			if($variables['user']->login != $_POST['modiduti']){
				if(component('acl')->check(
					$variables['user']->login,
					'user/password/#'
				)){
					$sameuser = true;
				}else{
					$iduti = $variables['user']->login;
				}
			}

			if($affich['password'] == substr(
				crypt($_POST['pass1'],"bt"),
				2)
				|| $sameuser
			){
				if($_POST['pass2'] == $_POST['pass3']){
					$pass = substr(crypt($_POST['pass2'], "bt"), 2);
					bdd_query("UPDATE {users} SET password='$pass' WHERE login='$iduti'");
					header('location: ' . base_path()
						. 'user/profile/' . $iduti
						. '/edit/ok'
					);
					exit;
				}else throw_error('user', 'notconcord');
			}else throw_error('user', 'badpass');
		}else throw_error('user', 'emptyfield');
	}else throw_error('404');
}

function user_modify(&$variables){
	if($variables['user']->is_logged()){
		if(isset($_POST['modiuti']) && !empty($_POST['modiuti'])){

			$sameuser = false;

			if($variables['user']->login == $_POST['modiduti']){
				$sameuser = true;
			}else{
				if(component('acl')->check(
					$variables['user']->login,
					'user/modify/#'
				)){
					$sameuser = true;
				}
			}


			if($sameuser){

				$data = array();

				$data['firstname'] = $_POST['firstname'];
				$data['lastname'] = $_POST['lastname'];

				$gravamod = strclean($_POST['gravamod']);
				if($gravamod == 'new'){
					$data['gravatar'] = md5($_POST['gravatar']);
				}else{
					$data['gravatar'] = $gravamod;
				}
				if(strlen($_POST['modlang']) == 5){
					$data['lang'] = strclean($_POST['modlang']);
				}

				$modiuti = new user($_POST['modiuti'], $data);
				$return = $modiuti->save();

				header('location: ' . base_path() . 'user/profile/'
					. $modiuti->login . '/edit/' . $return);
				exit;
			}
		}
	}
	throw_error('403');
}

function user_login(&$variables){
}

function user_connect(&$variables){
	use_modele('user');
	switch(get_arg(2)){
		case 'open' :
			if(isset($_POST['login']) &&
			isset($_POST['pass'])){
				$he = strclean($_POST['login']);
				$credential = false;

				switch(USER_AUTH_METHOD){
					case 'sql' :
						$contenu = bdd_query(
							"SELECT password,state FROM {users} WHERE login='$he'"
						);

						$affich = bdd_fetch($contenu);
						if(substr(
							crypt($_POST['pass'], "bt"),
							2
						) == $affich['password']){
							$credential = true;
							$state = $affich['state'];
						}
						break;
					case 'ldap' :
						if(ldap_connect_user(
							$he,
							strclean($_POST['pass'])
						)){
							$credential = true;

							$contenu = bdd_query(
								"SELECT state FROM {users} WHERE login='$he'"
							);

							if(bdd_count() > 0){
								$affich = bdd_fetch($contenu);
								$state = $affich['state'];
							}else{
								$newuser = new user(
									$he,
									array('state' => 'new')
								);

								$newuser->save();
								component('acl')->discover_user($he);
								$state = 1;
							}
						}
						break;
				}

				if($credential){
					if($state == 1){
						$outdated = time() + 31536000;
						$user_agent = $_SERVER['HTTP_USER_AGENT']
							. ' ' . $_SERVER['REMOTE_ADDR'];
						$key = get_secret_things(10);
						$iv = get_secret_things(
							mcrypt_get_iv_size(
								MCRYPT_RIJNDAEL_256,
								MCRYPT_MODE_CFB
							)
						);
						$arraykey = serialize(array($key, $iv));
						$mouette = cookie_nuts(
							$he . $outdated . $user_agent,
							$key,
							$iv
						);

						if(isset($_POST['session'])
							&& $_POST['session'] == 'bycookie')
							setcookie(
								'nougat',
								$mouette,
								$outdated,
								base_path()
							);
						else $_SESSION['nougat'] = $mouette;

						bdd_query("UPDATE {users} SET lastsid = '$outdated', arraykey = '$arraykey', sid = '$mouette' WHERE login = '$he'");
						header('location: '.base_path());exit;
					}else{
						throw_error('ufatal', 7);
					}
				}else{
					throw_error('ufatal', 1);
				}
			}
			break;
		case 'close' :
			setcookie('nougat','',0,base_path());
			session_unset();
			session_destroy();
			header('location: '.base_path());exit;
	}
}
?>
