<?php
/*
 * module/user/modele.php
 *
 * All Ouga code is released under the GNU General Public License.
 * See README and LICENSE.
 *
 */

define('USER_NOT_FOUND', -1);

class user {
	public $login = 'Anonymous';
	public $lastname;
	public $firstname;
	public $gravatar;
	public $lang;

	// state : enabled or banned
	private $state = 0;
	private $islogged = false;

	public function __construct($login = null, $data = null){
		/**
		 * On possède toutes les informations sur cet utilisateur
		 * Pour le modifier, ou l'enregistrer par exemple
		 */
		if($data != null){
			$this->login = strclean($login);

			$this->firstname = strclean($data['firstname']);
			$this->lastname = strclean($data['lastname']);
			$this->gravatar = strclean($data['gravatar']);
			$this->lang = strclean($data['lang']);
			$this->state = strclean($data['state']);

		/**
		 * On veut charger un utilisateur en particulier
		 */
		}else if($login != null){
			$this->load(strclean($login));

		/**
		 * Sinon on vérifie si la personne demandant la page est un membre
		 */
		}else{
			$this->check_connection();
		}

	}

	public function is_logged(){
		if($this->islogged) return true;
		return false;
	}

	public function get_state() {
		return $this->state;
	}

	public function get_gravatar($size = '40') {
		$default = path_to_theme().'img/avatar.png';
		return 'http://www.gravatar.com/avatar.php?gravatar_id='.$this->gravatar.'&default='.urlencode($default).'&size='.$size;
	}

	public function load($login){
		if(empty($login) || $login == '' || $login == null){
			$this->state = USER_NOT_FOUND;
			return false;
		}

		$contenu = bdd_query("SELECT p.login,p.lastname,p.firstname,p.state,p.gravatar,p.lang FROM {users} p WHERE p.login='$login'",true);
		$this->login = $login;

		if(bdd_count('num', $contenu) == 1){
			$thisuser = bdd_fetch($contenu);

			$this->lastname = $thisuser['lastname'];
			$this->firstname = $thisuser['firstname'];
			$this->state = $thisuser['state'];
			$this->gravatar = $thisuser['gravatar'];
			$this->lang = $thisuser['lang'];
			return true;
		}
		$this->state = USER_NOT_FOUND;
		return false;
	}

	private function check_connection(){
		$sid = false;
		if(isset($_SESSION['nougat'])){
			$sid = strclean($_SESSION['nougat']);
		}else if(isset($_COOKIE['nougat'])){
			$sid = strclean($_COOKIE['nougat']);
		}

		if($sid){
			$contenu = bdd_query("SELECT login, state, lastsid, arraykey FROM {users} WHERE sid='$sid'",true);
			$affich = bdd_fetch($contenu);

			if($affich['state'] == 1){
				$arraykey = unserialize($affich['arraykey']);
				$user_agent = $_SERVER['HTTP_USER_AGENT'].' '.$_SERVER['REMOTE_ADDR'];
				$anticollision = cookie_nuts(
					$affich['login'].$affich['lastsid'].$user_agent,$arraykey[0],$arraykey[1]
				);

				if($anticollision == $sid){
					if($this->load($affich['login'])){
						$this->islogged = true;
						return true;
					}
				}
			}
		}

		setcookie('nougat','',0,base_path());
		session_delete();

		$this->islogged = false;
		$this->login = 'Anonymous';
		return false;
	}

	public function save($new = '') {

		if($this->login != 'Anonymous'){

			if($this->state == 'new'){
				$pass = substr(crypt($new,"bt"),2);
				bdd_query("insert into {users}(login, password, state) values('".$this->login."', '".$pass."', 1)");
				return bdd_last_id();
			}else{
				$sql = '';

				$login = $this->login;
				if($this->firstname != '') $sql .= "firstname = '".$this->firstname."',";
				if($this->lastname != '') $sql .= "lastname = '".$this->lastname."',";
				if($this->gravatar != '') $sql .= "gravatar = '".$this->gravatar."',";
				if($this->lang != '') $sql .= "lang = '".$this->lang."',";

				$sql = substr($sql,0,-1);
				bdd_query("UPDATE {users} SET $sql WHERE login='$login'");
			}

			return 'ok';
		}
		return 'not_valid';
	}

	public function user_exists(){
		bdd_query("select login from {users} where login = '".$this->login."'");
		if(bdd_count() > 0) return true;
		return false;
	}

}

function list_users($criteria = null, $order = null, $join = null){

	$query = 'SELECT u.login,u.lastname,u.firstname,u.state,u.gravatar';

	if($join != null && is_array($join)){
		if(isset($join['field'])) $query .= ','.$join['fields'];
		$query .= ' FROM {users} u, '.$join['table'];
	}else $query .= ' FROM {users} u';

	if($criteria != null) $query .= ' WHERE '.$criteria;
	if($order != null) $query .= ' ORDER BY '.$order;

	$contenu = bdd_query($query, true);

	$listuser = array();

	while($affich = bdd_fetch($contenu)){
		$data = array(
			'lastname' => $affich['lastname'],
			'firstname' => $affich['firstname'],
			'gravatar' => $affich['gravatar'],
			'state' => $affich['state']
		);
		$listuser[$affich['login']] = new user($affich['login'], $data);
	}

	return $listuser;
}


// found on php.net website credit 'sdc'
function cookie_nuts($text,$key,$iv){
	return base64_encode(mcrypt_encrypt(MCRYPT_RIJNDAEL_256, $key, $text, MCRYPT_MODE_CFB, $iv));
}

function cookie_denuts($text,$key,$iv){
	return trim(mcrypt_decrypt(MCRYPT_RIJNDAEL_256, $key, base64_decode($text), MCRYPT_MODE_CFB, $iv));
}

function get_secret_things($nbr){
	$availablesigns = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZù*$çèé#&ø£µ%§~_@';
	$output = '';
	for ($i = 0; $i < $nbr; $i++) {
		$output .= substr($availablesigns,rand(0,41),1);
	}
	return $output;
}

?>
